/*header for Newton-Raphson optimization to get posterior mode estimate of F matrix*/


struct conv_info {/* convergence info for Newton-Raphson */
  int   xstatus;  /* exit status of Newton-Raphson */
  float   Gsum;   /* sum of absolute values of RHS of equations */
  float dFsum;    /*sum of abosolute values of changes in parameters */
  int feasible;   /*is this a feasible solution?*/
  int stepsrun;/*how many optimization steps did we run?*/
};

enum{xiter,ctolg,ctolf,ctolboth,LUfail};/*status on terminating Newton-Raphson*/

/*call the Newton-Raphson routine*/
/*F is a pointer to a vector of 5 elements: f00,f01,f10,f11,lambda, where lambda is Lagrange multiplier
N is a pointer to a vector of 4 elements: n00,n01,n10,n11
v and w are parameters of the beta distribution for prior on det F
tolG and tolF are tolerances for convergence test, sum of abs RHS of Lagrange system, and sum of abs changes in F at current iteration
niter is max iterations to run
cstatus is pointer to structure holding convergence info
F and cstatus will be set by FNewton*/
void FNewton(float *F,int *N,float v,float w,float tolG,float tolF,int niter,struct conv_info *cstatus);


/*test functions*/
void printFmatrix(float *F);
void print_convinfo(struct conv_info cstatus);
